Index: src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_subtemplate.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_subtemplate.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_subtemplate.php	(revision )
@@ -0,0 +1,203 @@
+<?php
+
+/**
+ * Sub Template Runtime Methods render, setupSubTemplate
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ *
+ **/
+class Smarty_Internal_Runtime_SubTemplate
+{
+
+    /**
+     * Subtemplate template object cache
+     *
+     * @var Smarty_Internal_Template[]
+     */
+    public $tplObjects = array();
+
+    /**
+     * Subtemplate call count
+     *
+     * @var int[]
+     */
+    public $subTplInfo = array();
+
+    /**
+     * Runtime function to render subtemplate
+     *
+     * @param \Smarty_Internal_Template $parent
+     * @param string                    $template       template name
+     * @param mixed                     $cache_id       cache id
+     * @param mixed                     $compile_id     compile id
+     * @param integer                   $caching        cache mode
+     * @param integer                   $cache_lifetime life time of cache data
+     * @param array                     $data           passed parameter template variables
+     * @param int                       $scope          scope in which {include} should execute
+     * @param bool                      $forceTplCache  cache template object
+     * @param string                    $uid            file dependency uid
+     * @param string                    $content_func   function name
+     *
+     */
+    public function render(Smarty_Internal_Template $parent, $template, $cache_id, $compile_id, $caching,
+                           $cache_lifetime, $data, $scope, $forceTplCache, $uid = null, $content_func = null)
+    {
+        // if there are cached template objects calculate $templateID
+        $_templateId =
+            !empty($this->tplObjects) ? $parent->smarty->_getTemplateId($template, $cache_id, $compile_id, $caching) :
+                null;
+        // already in template cache?
+        /* @var Smarty_Internal_Template $tpl */
+        if (isset($_templateId) && isset($this->tplObjects[$_templateId])) {
+            // clone cached template object because of possible recursive call
+            $tpl = clone $this->tplObjects[$_templateId];
+            $tpl->parent = $parent;
+            // if $caching mode changed the compiled resource is invalid
+            if ((bool) $tpl->caching !== (bool) $caching) {
+                unset($tpl->compiled);
+            }
+            // get variables from calling scope
+            $tpl->tpl_vars = $parent->tpl_vars;
+            $tpl->config_vars = $parent->config_vars;
+            // get template functions
+            $tpl->tpl_function = $parent->tpl_function;
+            // copy inheritance object?
+            if (isset($parent->ext->_inheritance)) {
+                $tpl->ext->_inheritance = $parent->ext->_inheritance;
+            } else {
+                unset($tpl->ext->_inheritance);
+            }
+        } else {
+            $tpl = clone $parent;
+            $tpl->parent = $parent;
+            if (!isset($tpl->templateId) || $tpl->templateId !== $_templateId) {
+                $tpl->templateId = $_templateId;
+                $tpl->template_resource = $template;
+                $tpl->cache_id = $cache_id;
+                $tpl->compile_id = $compile_id;
+                if (isset($uid)) {
+                    // for inline templates we can get all resource information from file dependency
+                    if (isset($tpl->compiled->file_dependency[$uid])) {
+                        list($filepath, $timestamp, $resource) = $tpl->compiled->file_dependency[$uid];
+                        $tpl->source =
+                            new Smarty_Template_Source(isset($tpl->smarty->_cache['resource_handlers'][$resource]) ?
+                                                           $tpl->smarty->_cache['resource_handlers'][$resource] :
+                                                           Smarty_Resource::load($tpl->smarty, $resource), $tpl->smarty,
+                                                       $filepath, $resource, $filepath);
+                        $tpl->source->filepath = $filepath;
+                        $tpl->source->timestamp = $timestamp;
+                        $tpl->source->exists = true;
+                        $tpl->source->uid = $uid;
+                    } else {
+                        $tpl->source = null;
+                    }
+                } else {
+                    $tpl->source = null;
+                }
+                if (!isset($tpl->source)) {
+                    $tpl->source = Smarty_Template_Source::load($tpl);
+                    unset($tpl->compiled);
+                }
+                unset($tpl->cached);
+            }
+        }
+        $tpl->caching = $caching;
+        $tpl->cache_lifetime = $cache_lifetime;
+        if ($caching == 9999) {
+            $tpl->cached = $parent->cached;
+        }
+        // set template scope
+        $tpl->scope = $scope;
+        $scopePtr = false;
+        if ($scope & ~Smarty::SCOPE_BUBBLE_UP) {
+            if ($scope == Smarty::SCOPE_GLOBAL) {
+                $tpl->tpl_vars = Smarty::$global_tpl_vars;
+                $tpl->config_vars = $tpl->smarty->config_vars;
+                $scopePtr = true;
+            } else {
+                if ($scope == Smarty::SCOPE_PARENT) {
+                    $scopePtr = $parent;
+                } elseif ($scope == Smarty::SCOPE_SMARTY) {
+                    $scopePtr = $tpl->smarty;
+                } else {
+                    $scopePtr = $tpl;
+                    while (isset($scopePtr->parent)) {
+                        if ($scopePtr->parent->_objType != 2 && $scope & Smarty::SCOPE_TPL_ROOT) {
+                            break;
+                        }
+                        $scopePtr = $scopePtr->parent;
+                    }
+                }
+                $tpl->tpl_vars = $scopePtr->tpl_vars;
+                $tpl->config_vars = $scopePtr->config_vars;
+            }
+        }
+
+        if (!isset($this->tplObjects[$tpl->_getTemplateId()]) && !$tpl->source->handler->recompiled) {
+            // if template is called multiple times set flag to to cache template objects
+            $forceTplCache = $forceTplCache ||
+                (isset($this->subTplInfo[$tpl->template_resource]) && $this->subTplInfo[$tpl->template_resource] > 1);
+            // check if template object should be cached
+            if ($tpl->parent->_objType == 2 && isset($this->tplObjects[$tpl->parent->templateId]) ||
+                ($forceTplCache && $tpl->smarty->resource_cache_mode & Smarty::RESOURCE_CACHE_AUTOMATIC) ||
+                ($tpl->smarty->resource_cache_mode & Smarty::RESOURCE_CACHE_ON)
+            ) {
+                $this->tplObjects[$tpl->_getTemplateId()] = $tpl;
+            }
+        }
+
+        if (!empty($data)) {
+            // set up variable values
+            foreach ($data as $_key => $_val) {
+                $tpl->tpl_vars[$_key] = new Smarty_Variable($_val);
+            }
+        }
+        if (isset($uid)) {
+            if ($parent->smarty->debugging) {
+                $parent->smarty->_debug->start_template($tpl);
+                $parent->smarty->_debug->start_render($tpl);
+            }
+            $tpl->compiled->getRenderedTemplateCode($tpl, $content_func);
+            if ($parent->smarty->debugging) {
+                $parent->smarty->_debug->end_template($tpl);
+                $parent->smarty->_debug->end_render($tpl);
+            }
+            if ($tpl->caching == 9999 && $tpl->compiled->has_nocache_code) {
+                $parent->cached->hashes[$tpl->compiled->nocache_hash] = true;
+            }
+        } else {
+            if (isset($tpl->compiled)) {
+                $tpl->compiled->render($tpl);
+            } else {
+                $tpl->render();
+            }
+        }
+        if ($scopePtr) {
+            if ($scope == Smarty::SCOPE_GLOBAL) {
+                Smarty::$global_tpl_vars = $tpl->tpl_vars;
+                $tpl->smarty->config_vars = $tpl->config_vars;
+            } else {
+                $scopePtr->tpl_vars = $tpl->tpl_vars;
+                $scopePtr->config_vars = $tpl->config_vars;
+            }
+        }
+    }
+
+    /**
+     * Get called subtemplates from compiled template and save call count
+     *
+     * @param \Smarty_Internal_Template $tpl
+     */
+    public function registerSubTemplates(Smarty_Internal_Template $tpl)
+    {
+        foreach ($tpl->compiled->includes as $name => $count) {
+            if (isset($this->subTplInfo[$name])) {
+                $this->subTplInfo[$name] += $count;
+            } else {
+                $this->subTplInfo[$name] = $count;
+            }
+        }
+    }
+}
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_compile_private_modifier.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_compile_private_modifier.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_compile_private_modifier.php	(revision )
@@ -20,13 +20,14 @@
     /**
      * Compiles code for modifier execution
      *
-     * @param  array  $args      array with attributes from parser
+     * @param  array                                $args      array with attributes from parser
-     * @param  object $compiler  compiler object
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler  compiler object
-     * @param  array  $parameter array with compilation parameter
+     * @param  array                                $parameter array with compilation parameter
      *
      * @return string compiled code
+     * @throws \SmartyCompilerException
      */
-    public function compile($args, $compiler, $parameter)
+    public function compile($args, Smarty_Internal_TemplateCompilerBase $compiler, $parameter)
     {
         // check and get attributes
         $_attr = $this->getAttributes($compiler, $args);
@@ -52,7 +53,8 @@
                                 $output = "{$function}({$params})";
                             } else {
                                 if (is_object($function[0])) {
-                                    $output = '$_smarty_tpl->smarty->registered_plugins[Smarty::PLUGIN_MODIFIER][\'' . $modifier . '\'][0][0]->' . $function[1] . '(' . $params . ')';
+                                    $output = '$_smarty_tpl->smarty->registered_plugins[Smarty::PLUGIN_MODIFIER][\'' .
+                                        $modifier . '\'][0][0]->' . $function[1] . '(' . $params . ')';
                                 } else {
                                     $output = $function[0] . '::' . $function[1] . '(' . $params . ')';
                                 }
@@ -73,7 +75,9 @@
                         // modifiercompiler plugin
                         if ($compiler->smarty->loadPlugin('smarty_modifiercompiler_' . $modifier)) {
                             // check if modifier allowed
-                            if (!is_object($compiler->smarty->security_policy) || $compiler->smarty->security_policy->isTrustedModifier($modifier, $compiler)) {
+                            if (!is_object($compiler->smarty->security_policy) ||
+                                $compiler->smarty->security_policy->isTrustedModifier($modifier, $compiler)
+                            ) {
                                 $plugin = 'smarty_modifiercompiler_' . $modifier;
                                 $output = $plugin($single_modifier, $compiler);
                             }
@@ -85,7 +89,9 @@
                         // modifier plugin
                         if ($function = $compiler->getPlugin($modifier, Smarty::PLUGIN_MODIFIER)) {
                             // check if modifier allowed
-                            if (!is_object($compiler->smarty->security_policy) || $compiler->smarty->security_policy->isTrustedModifier($modifier, $compiler)) {
+                            if (!is_object($compiler->smarty->security_policy) ||
+                                $compiler->smarty->security_policy->isTrustedModifier($modifier, $compiler)
+                            ) {
                                 $output = "{$function}({$params})";
                             }
                             $compiler->known_modifier_type[$modifier] = $type;
@@ -96,7 +102,9 @@
                         // PHP function
                         if (is_callable($modifier)) {
                             // check if modifier allowed
-                            if (!is_object($compiler->smarty->security_policy) || $compiler->smarty->security_policy->isTrustedPhpModifier($modifier, $compiler)) {
+                            if (!is_object($compiler->smarty->security_policy) ||
+                                $compiler->smarty->security_policy->isTrustedPhpModifier($modifier, $compiler)
+                            ) {
                                 $output = "{$modifier}({$params})";
                             }
                             $compiler->known_modifier_type[$modifier] = $type;
@@ -105,21 +113,29 @@
                         break;
                     case 6:
                         // default plugin handler
-                        if (isset($compiler->default_handler_plugins[Smarty::PLUGIN_MODIFIER][$modifier]) || (is_callable($compiler->smarty->default_plugin_handler_func) && $compiler->getPluginFromDefaultHandler($modifier, Smarty::PLUGIN_MODIFIER))) {
+                        if (isset($compiler->default_handler_plugins[Smarty::PLUGIN_MODIFIER][$modifier]) ||
+                            (is_callable($compiler->smarty->default_plugin_handler_func) &&
+                                $compiler->getPluginFromDefaultHandler($modifier, Smarty::PLUGIN_MODIFIER))
+                        ) {
                             $function = $compiler->default_handler_plugins[Smarty::PLUGIN_MODIFIER][$modifier][0];
                             // check if modifier allowed
-                            if (!is_object($compiler->smarty->security_policy) || $compiler->smarty->security_policy->isTrustedModifier($modifier, $compiler)) {
+                            if (!is_object($compiler->smarty->security_policy) ||
+                                $compiler->smarty->security_policy->isTrustedModifier($modifier, $compiler)
+                            ) {
                                 if (!is_array($function)) {
                                     $output = "{$function}({$params})";
                                 } else {
                                     if (is_object($function[0])) {
-                                        $output = '$_smarty_tpl->smarty->registered_plugins[Smarty::PLUGIN_MODIFIER][\'' . $modifier . '\'][0][0]->' . $function[1] . '(' . $params . ')';
+                                        $output = '$_smarty_tpl->smarty->registered_plugins[Smarty::PLUGIN_MODIFIER][\'' .
+                                            $modifier . '\'][0][0]->' . $function[1] . '(' . $params . ')';
                                     } else {
                                         $output = $function[0] . '::' . $function[1] . '(' . $params . ')';
                                     }
                                 }
                             }
-                            if (isset($compiler->template->required_plugins['nocache'][$modifier][Smarty::PLUGIN_MODIFIER]['file']) || isset($compiler->template->required_plugins['compiled'][$modifier][Smarty::PLUGIN_MODIFIER]['file'])) {
+                            if (isset($compiler->parent_compiler->template->compiled->required_plugins['nocache'][$modifier][Smarty::PLUGIN_MODIFIER]['file']) ||
+                                isset($compiler->parent_compiler->template->compiled->required_plugins['compiled'][$modifier][Smarty::PLUGIN_MODIFIER]['file'])
+                            ) {
                                 // was a plugin
                                 $compiler->known_modifier_type[$modifier] = 4;
                             } else {
@@ -130,7 +146,7 @@
                 }
             }
             if (!isset($compiler->known_modifier_type[$modifier])) {
-                $compiler->trigger_template_error("unknown modifier \"" . $modifier . "\"", $compiler->lex->taglineno);
+                $compiler->trigger_template_error("unknown modifier \"" . $modifier . "\"", null, true);
             }
         }
 
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_getautoloadfilters.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_getautoloadfilters.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_getautoloadfilters.php	(revision )
@@ -0,0 +1,37 @@
+<?php
+
+/**
+ * Smarty Method GetAutoloadFilters
+ *
+ * Smarty::getAutoloadFilters() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_GetAutoloadFilters extends Smarty_Internal_Method_SetAutoloadFilters
+{
+
+    /**
+     * Get autoload filters
+     *
+     * @api Smarty::getAutoloadFilters()
+     *
+     * @param \Smarty_Internal_TemplateBase|\Smarty_Internal_Template|\Smarty $obj
+     * @param  string                                                         $type type of filter to get auto loads
+     *                                                                              for. Defaults to all autoload
+     *                                                                              filters
+     *
+     * @return array  array( 'type1' => array( 'filter1', 'filter2', … ) ) or array( 'filter1', 'filter2', …) if $type
+     *                was specified
+     */
+    public function getAutoloadFilters(Smarty_Internal_TemplateBase $obj, $type = null)
+    {
+        $smarty = isset($obj->smarty) ? $obj->smarty : $obj;
+        if ($type !== null) {
+            $this->_checkFilterType($type);
+            return isset($smarty->autoload_filters[$type]) ? $smarty->autoload_filters[$type] : array();
+        }
+        return $smarty->autoload_filters;
+    }
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_resource_string.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_resource_string.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_resource_string.php	(revision )
@@ -73,11 +73,11 @@
      *
      * @param  Smarty  $smarty        Smarty instance
      * @param  string  $resource_name resource_name to make unique
-     * @param  boolean $is_config     flag for config resource
+     * @param  boolean $isConfig      flag for config resource
      *
      * @return string unique resource name
      */
-    protected function buildUniqueResourceName(Smarty $smarty, $resource_name, $is_config = false)
+    public function buildUniqueResourceName(Smarty $smarty, $resource_name, $isConfig = false)
     {
         return get_class($this) . '#' . $this->decode($resource_name);
     }
@@ -90,7 +90,7 @@
      *
      * @return string                 resource's basename
      */
-    protected function getBasename(Smarty_Template_Source $source)
+    public function getBasename(Smarty_Template_Source $source)
     {
         return '';
     }
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_setdebugtemplate.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_setdebugtemplate.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_setdebugtemplate.php	(revision )
@@ -0,0 +1,41 @@
+<?php
+
+/**
+ * Smarty Method SetDebugTemplate
+ *
+ * Smarty::setDebugTemplate() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_SetDebugTemplate
+{
+    /**
+     * Valid for Smarty and template object
+     *
+     * @var int
+     */
+    public $objMap = 3;
+
+    /**
+     * set the debug template
+     *
+     * @api Smarty::setDebugTemplate()
+     *
+     * @param \Smarty_Internal_TemplateBase|\Smarty_Internal_Template|\Smarty $obj
+     * @param  string                                                         $tpl_name
+     *
+     * @return \Smarty|\Smarty_Internal_Template
+     * @throws SmartyException if file is not readable
+     */
+    public function setDebugTemplate(Smarty_Internal_TemplateBase $obj, $tpl_name)
+    {
+        $smarty = isset($obj->smarty) ? $obj->smarty : $obj;
+        if (!is_readable($tpl_name)) {
+            throw new SmartyException("Unknown file '{$tpl_name}'");
+        }
+        $smarty->debug_tpl = $tpl_name;
+        return $obj;
+    }
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_hhvm.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_hhvm.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_hhvm.php	(revision )
@@ -0,0 +1,30 @@
+<?php
+
+/**
+ * Runtime Extension Hhvm
+ *
+ * include patch for modified compiled or cached templates
+ * HHVM does not check if file was modified when including same file multiple times
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Runtime_Hhvm
+{
+    /**
+     * @param \Smarty_Internal_Template $_template
+     * @param string                    $file file name
+     *
+     * @return mixed
+     */
+    static function includeHhvm(Smarty_Internal_Template $_template, $file)
+    {
+        $_smarty_tpl = $_template;
+        $tmp_file = $file . preg_replace('![^\w]+!', '_', uniqid(rand(), true)) . '.php';
+        file_put_contents($tmp_file, file_get_contents($file));
+        $result = @include $tmp_file;
+        @unlink($tmp_file);
+        return $result;
+    }
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/sysplugins/smarty_resource_recompiled.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_resource_recompiled.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_resource_recompiled.php	(revision )
@@ -17,6 +17,20 @@
 abstract class Smarty_Resource_Recompiled extends Smarty_Resource
 {
     /**
+     * Flag that it's an recompiled resource
+     *
+     * @var bool
+     */
+    public $recompiled = true;
+
+    /**
+     * Resource does implement populateCompiledFilepath() method
+     *
+     * @var bool
+     */
+    public $hasCompiledHandler = true;
+
+    /**
      * populate Compiled Object with compiled filepath
      *
      * @param  Smarty_Template_Compiled $compiled  compiled object
Index: src/includes/classes/Smarty/plugins/block.textformat.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/plugins/block.textformat.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/plugins/block.textformat.php	(revision )
@@ -1,0 +1,0 @@
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_filterhandler.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_filterhandler.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_runtime_filterhandler.php	(revision )
@@ -0,0 +1,69 @@
+<?php
+/**
+ * Smarty Internal Plugin Filter Handler
+ * Smarty filter handler class
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+
+/**
+ * Class for filter processing
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ */
+class Smarty_Internal_Runtime_FilterHandler
+{
+    /**
+     * Run filters over content
+     * The filters will be lazy loaded if required
+     * class name format: Smarty_FilterType_FilterName
+     * plugin filename format: filtertype.filtername.php
+     * Smarty2 filter plugins could be used
+     *
+     * @param  string                   $type     the type of filter ('pre','post','output') which shall run
+     * @param  string                   $content  the content which shall be processed by the filters
+     * @param  Smarty_Internal_Template $template template object
+     *
+     * @throws SmartyException
+     * @return string                   the filtered content
+     */
+    public function runFilter($type, $content, Smarty_Internal_Template $template)
+    {
+        // loop over autoload filters of specified type
+        if (!empty($template->smarty->autoload_filters[$type])) {
+            foreach ((array) $template->smarty->autoload_filters[$type] as $name) {
+                $plugin_name = "Smarty_{$type}filter_{$name}";
+                if (function_exists($plugin_name)) {
+                    $callback = $plugin_name;
+                } elseif (class_exists($plugin_name, false) && is_callable(array($plugin_name, 'execute'))) {
+                    $callback = array($plugin_name, 'execute');
+                } elseif ($template->smarty->loadPlugin($plugin_name, false)) {
+                    if (function_exists($plugin_name)) {
+                        // use loaded Smarty2 style plugin
+                        $callback = $plugin_name;
+                    } elseif (class_exists($plugin_name, false) && is_callable(array($plugin_name, 'execute'))) {
+                        // loaded class of filter plugin
+                        $callback = array($plugin_name, 'execute');
+                    } else {
+                        throw new SmartyException("Auto load {$type}-filter plugin method \"{$plugin_name}::execute\" not callable");
+                    }
+                } else {
+                    // nothing found, throw exception
+                    throw new SmartyException("Unable to auto load {$type}-filter plugin \"{$plugin_name}\"");
+                }
+                $content = call_user_func($callback, $content, $template);
+            }
+        }
+        // loop over registered filters of specified type
+        if (!empty($template->smarty->registered_filters[$type])) {
+            foreach ($template->smarty->registered_filters[$type] as $key => $name) {
+                $content = call_user_func($template->smarty->registered_filters[$type][$key], $content, $template);
+            }
+        }
+        // return filtered output
+        return $content;
+    }
+}
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_appendbyref.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_appendbyref.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_appendbyref.php	(revision )
@@ -0,0 +1,50 @@
+<?php
+
+/**
+ * Smarty Method AppendByRef
+ *
+ * Smarty::appendByRef() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_AppendByRef
+{
+
+    /**
+     * appends values to template variables by reference
+     *
+     * @api  Smarty::appendByRef()
+     * @link http://www.smarty.net/docs/en/api.append.by.ref.tpl
+     *
+     * @param \Smarty_Internal_Data|\Smarty_Internal_Template|\Smarty $data
+     * @param  string                                                 $tpl_var the template variable name
+     * @param  mixed                                                  &$value  the referenced value to append
+     * @param  bool                                                   $merge   flag if array elements shall be merged
+     *
+     * @return \Smarty_Internal_Data|\Smarty_Internal_Template|\Smarty
+     */
+    public static function appendByRef(Smarty_Internal_Data $data, $tpl_var, &$value, $merge = false)
+    {
+        if ($tpl_var != '' && isset($value)) {
+            if (!isset($data->tpl_vars[$tpl_var])) {
+                $data->tpl_vars[$tpl_var] = new Smarty_Variable();
+            }
+            if (!is_array($data->tpl_vars[$tpl_var]->value)) {
+                settype($data->tpl_vars[$tpl_var]->value, 'array');
+            }
+            if ($merge && is_array($value)) {
+                foreach ($value as $_key => $_val) {
+                    $data->tpl_vars[$tpl_var]->value[$_key] = &$value[$_key];
+                }
+            } else {
+                $data->tpl_vars[$tpl_var]->value[] = &$value;
+            }
+            if ($data->_objType == 2 && $data->scope) {
+                $data->ext->_updateScope->updateScope($data, $tpl_var);
+            }
+        }
+        return $data;
+    }
+}
\ No newline at end of file
